Subject: Re: bug#59693: 29.0.50; treesitter in base buffer doesn't respond to modifications in indirect buffer correctly

From: Eli Zaretskii <[email-masked]>
Date: Mon, 05 Dec 2022 17:44:49 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: Yuan Fu <[email-masked]>,  [email-masked],  [email-masked]
> Date: Mon, 05 Dec 2022 10:29:06 -0500
> 
> > Will this "hold water" vis-a-vis the expectations of various features that
> > would like to use tree sitter related capabilities?  Regardless of your
> > opinion on indirect buffers, many 3rd party packages and features use
> > indirect buffers as the backbone of their implementation.  We don't
> > currently have any alternatives to that, AFAIK.  So I'd expect a lot of
> > disappointment if we declare that indirect buffers will not be supported by
> > tree sitter as a matter of design decision.
> 
> I can't see why: a package that uses indirect buffers can just as well
> run its tree-sitter parsers in the base buffer.

I thought about those multi-mode modes, or features that show the same
buffer more than once with different modes.

> > Changing insdel.c to run stuff in base buffer could be a solution, but
> > I don't feel we can make such changes on the release branch.
> 
> Agreed.
> 
> > But maybe we can do that now only for treesit.c functions.
> 
> Sounds OK to me, yes.

OK, thanks.  Yuan, will this work for you? can you show a patch along these
lines?